(*
	embedLyrics.applescript for TunesTEXT
	ver 1.0
		for iTunes 5 or later
*)

-- Generate path to temporary file
set tmpPath to POSIX path of (path to temporary items folder)
set tmpPath to tmpPath & "TunesTEXTLyricsTemporaryFile.txt"

-- Open temporary file
try
	set theText to (do shell script "cat " & quoted form of tmpPath) as Unicode text
on error
	return "Open temporary file failed: " & tmpPath
end try

-- Read temporary file
try
	set oldDelim to AppleScript's text item delimiters -- Escape default delimiter
	set AppleScript's text item delimiters to "_IsIdentifierNumberOfTargetTrackToEmbedLyrics_"
	set targetTrackID to text item 1 of theText as number -- OS X 10.5 later
	set theLyrics to (text item 2 of theText) as Unicode text
	set AppleScript's text item delimiters to oldDelim
on error
	return "Read temporary file failed: " & tmpPath
end try

-- Embed lyrics
tell application "iTunes"
	-- set theLibrary to a reference to library playlist 1
	set theLibrary to a reference to the current playlist
	set targetTrack to some track of theLibrary whose database ID is targetTrackID
	
	-- iTunes 7.7.1 returns the track as a list
	if the class of targetTrack = list then
		set targetTrack to the item 1 of targetTrack
	end if
	
	-- Embed the lyrics
	try
		set the lyrics of targetTrack to theLyrics
	on error
		return "Embed lyrics failed 1: " & targetTrackID
	end try
	
	-- Confirm
	if not (the lyrics of targetTrack is theLyrics) then
		return "Embed lyrics failed 2: " & targetTrackID
	end if
end tell

return "success"
